#ifndef NICESHAPER_H
#define NICESHAPER_H

#define version "0.6rc3"

#include <unistd.h>		
#include <stdlib.h>		
#include <signal.h>		
#include <sys/wait.h>
#include <fcntl.h>		
#include <netdb.h>		
#include <arpa/inet.h>		
#include <sys/time.h>		
#include <sys/types.h>		
#include <iostream>
#include <vector>
#include <string>


const int LONG_BUF = 256;
const int SHORT_BUF = 32;
const int LONG_IP_ADDR = 32;
const int SHORT_IP_ADDR = 16;
const int MAX_IFACE = 12;
const int MAX_PATH = 256;

enum unittype { bps = 8, kbps = 8192, mbps = 8388608, bit = 1, kbit = 1024, mbit = 1048576 };
enum filtertype { u32 = 1, fw = 2 };
enum classtype { standard = 1, donotshape = 2, virtualclass = 3, wrapper = 4 };
enum qdisctype { none = 1, sfq = 2 };
enum langtype { en = 1 , pl = 2 };

void run(int, char *[]);
void signalterm(int);
void show_stats();
void iptohostname(char[], char[]);
void sys(char[]);
int dotobit(char[]);
bool bitodot(char[], int);
bool getip(char[], char[]);
int split(char[], char[], char[]);
int valid_dev(char[]);
bool valid_ip(char[]);
bool solid_ipmask(char[]);
bool valid_port(int);
bool valid_whiteline(char[]);
int trim(char[]);
char *awk(char[], unsigned int);
long int unitconvert(char[], unittype);
long int unitconvert(long int, unittype);
int gen_ipt_filter(char[], char[]);
void convert_usersfile();
void help();
void system_ipt(char[]);
void system_tc(char[]);
enum unittype getunit(char[]);
unsigned int compute_quantum (unsigned int);
long int power( int , int );
int conv_to_fpv ( std::vector < char * > &, FILE *, char []);
int fpv_section_i ( std::vector < char * >::iterator &, std::vector < char * >::iterator &, std::vector < char * > &, char [] );

extern char conffile[MAX_PATH];
extern char classfile[MAX_PATH];

extern char section[SHORT_BUF];
extern char ipt_mychain[15];
extern char ipt_myparent[15];

extern unsigned int working;
extern unsigned int section_htb_ceil;
extern unsigned int section_shape;
extern unsigned int section_interactive_sum;
extern unsigned int section_id;
extern unsigned int section_max_permills;
extern unittype statsunit;
extern char chstatsunit[8];
extern char markifaces[LONG_BUF];
extern bool overload;
extern bool debug_ipt;
extern bool debug_tc;
extern bool i_am_parent;

#endif
